#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <direct.h>
#include <windows.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
extern int errno;
/* splitdir -- Copies a directory and all subdirectoriesinto multiple 
	subdirectories, each no larger than a specified size
    Copyright (C) 2003  Norm London, London Computing

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	norm_london@londoncomputing.com

    Compile with Visual Studio.NET
	
*/
int mk_all_dir(char *path_buffer) {
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	char new_level[_MAX_PATH];
	struct stat dta;
	int k;
	k = strlen(path_buffer) - 1;
	if (k > 0 && (path_buffer[k] == '\\' || path_buffer[k] == '/'))
		path_buffer[k] = 0;
	/*   printf("mk_all_dir: %s\n",path_buffer); */
	_splitpath( path_buffer, drive, dir, fname, ext );
	_makepath( new_level, drive, dir, "","");
	/*   printf("\t%s\n",new_level); */
	if (strcmp(dir,"\\")==0 || strcmp(dir,"/")==0 || fname[0] == 0 ||
	    (stat(new_level,&dta) == 0 &&  (dta.st_mode & S_IFDIR)))
		;
	else
		mk_all_dir(new_level);
	return mkdir(path_buffer);
}

void Usage(void) {
	FILE *hlp;
	char tmp[_MAX_PATH];
	char cmd[_MAX_PATH];
	char wtmp[_MAX_PATH],*wp;

	if ((wp=getenv("tmp")) == NULL)
		if ((wp = getenv("temp")) == NULL)
			strcpy(wtmp,"./");
		else
			strcpy(wtmp,wp);
	else
		strcpy(wtmp,wp);
	if (wtmp[strlen(wtmp)-1] != '/' && wtmp[strlen(wtmp)-1] != '\\')
		strcat(wtmp,"/");

	strcat(wtmp,"splitdir.hlp");
	hlp = fopen(wtmp,"w");

    fprintf(hlp,"splitdir -- %s \n",__DATE__);
	fprintf(hlp,"\nCopyright 2005, Norm London, London Computing.\nnorm_london@londoncomputing.com\n\n");
    fprintf(hlp,"This program is free software; you can redistribute it and/or modify\n");
	fprintf(hlp,"it under the terms of the GNU General Public License as published by\n");
	fprintf(hlp,"the Free Software Foundation; either version 2 of the License, or\n");
	fprintf(hlp,"(at your option) any later version.\n\n");
	fprintf(hlp,"This program is distributed in the hope that it will be useful,\n");
	fprintf(hlp,"but WITHOUT ANY WARRANTY; without even the implied warranty of\n");
	fprintf(hlp,"MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n");
	fprintf(hlp,"GNU General Public License for more details.\n\n");
	fprintf(hlp,"You should have received a copy of the GNU General Public License\n");
	fprintf(hlp,"along with this program; if not, write to the Free Software\n");
	fprintf(hlp,"Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA\n\n");
	fprintf(hlp,"Written by London Computing, PO Box 696, Cherry Hill, NJ 08003.\n");
	fprintf(hlp,"www.londoncomputing.com\n\n");
	fprintf(hlp,"Usage is:\nsplitdir inputdirectory outputdirectory maxdirectorysize\n");
	fprintf(hlp,"Copies the files and directories in the inputdirectory to the outputdirectory,\n");
	fprintf(hlp,"creating multiple subdirectories no larger than maxdirectorysize.  The \n");
	fprintf(hlp,"first subdirectory is named CD00001.  If more subdirectories are created\n");
	fprintf(hlp,"they are named CD00002 ...  Individual files are not split between directories.\n\n");
	
	fprintf(hlp,"Maxdirectorysize can be specified in bytes as nnn, in KB as nnnKB, in MB as nnnMB\n");
	fprintf(hlp,"or in GB as nnnGB.\n");
	fclose(hlp);
	sprintf(cmd,"notepad.exe %s",wtmp);
	WinExec(cmd,SW_SHOW);
	return;
}


int main(int argc,char *argv[]) {
_int64 totalsize=0x3fffffffffffffff;
_int64 currentsize;
char filepath[_MAX_PATH];
int cdnbr=100000, rc=0;
char filename[_MAX_PATH], cdstr[8], indir[_MAX_PATH], prevdir[_MAX_PATH];
char outdir[_MAX_PATH],newdir[_MAX_PATH],tempdir[_MAX_PATH];
_int64 maxsize;
int len, kb=0, mb=0, gb=0, i;
char *KMG, cmd[4096];
char inputbuffer[2048], *t1,*t2,*t3, temp1[_MAX_PATH], temp2[_MAX_PATH];
FILE *filelist;
PVOID *lpMsgBuf;
   char drive[_MAX_DRIVE];
   char dir[_MAX_DIR];
   char fname[_MAX_FNAME];
   char ext[_MAX_EXT];
   struct _stati64 statbuf;



if (argc < 4) {
	Usage();
	return 4;
}

// Get temp filename
strcpy(filepath,_tempnam(NULL,"_SplitDir"));
// create file name for output file

strcpy(cmd,strupr(argv[3]));

// Get directory size,  The max size can be specified in bytes, KB, MB or GB
if (KMG = strchr(cmd,'K')) {kb = 1;	*KMG = 0;}
else if (KMG = strchr(cmd,'M')) {mb = 1;*KMG = 0;}
else if (KMG = strchr(cmd,'G')) {gb = 1;*KMG = 0;}

// set the maximum size
	maxsize = atol(cmd);
	if (kb)	maxsize *= 1024;
	else if (mb) maxsize *= 1024*1024;
	else if (gb) maxsize *= 1024*1024*1024;

 t1=temp1;
 t2=temp2;
 *prevdir = 0; //set prev path to empty
  GetFullPathName(argv[2],sizeof(outdir),outdir,t1);
  _mkdir(outdir);
  GetFullPathName(argv[1],sizeof(indir),indir,t2);

// search the input directory to create a list of files to copy
	sprintf(cmd,"dir \"%s\" /s /b>%s",indir,filepath);
	rc=system(cmd);

	filelist = fopen(filepath,"r");
// read the input file created by SEARCH32
	while(fgets(inputbuffer,sizeof(inputbuffer),filelist)!= NULL) {
		// modified to read the file name only
		// need to parse it so that we have file name and pathname
		inputbuffer[strlen(inputbuffer)-1]=0;
		_splitpath(inputbuffer,drive,dir,filename,ext);
		strcpy(filepath,drive);
		strcat(filepath,dir);
		strcat(filename,ext);
		// get info about input buffer it
		rc = _stati64(inputbuffer,&statbuf);
		if (rc < 0)
			perror(inputbuffer);
		if (statbuf.st_mode & _S_IFDIR)
			continue;
		currentsize = statbuf.st_size;
		totalsize += currentsize;
		if (totalsize > maxsize) {	
			// Total size copied into directory would exceed maximum
			// create a new subdirectory
			strcpy(newdir,outdir);
			sprintf(cdstr,"%d",++cdnbr);
			strcat(newdir,"/CD");
			strcat(newdir,cdstr+1);	
			totalsize = currentsize;
			if (mk_all_dir(newdir) == -1) {
				// error occurred making the output directory
				switch(errno) {
					case EEXIST:
						// Directory already exists, ignore
						break;
					case ENOENT:
						fprintf(stderr,"Unable to create directory (Path does not exist.): %s\n",newdir);
						return 4;
						break;
					default:
						fprintf(stderr,"Unable to create directory (Error %d): %s\n",errno,newdir);
						return 4;
						break;
				}
			}
			else {
				strcpy(prevdir,newdir);
				strcat(prevdir,"\\");
			}
		}
//		Build the from and to file names
		
		sprintf(temp1,"%s%s",filepath,filename);
		sprintf(temp2,"%s%s",newdir,filepath+strlen(indir));
		if (stricmp(prevdir,temp2)) {
			if (mk_all_dir(temp2) == -1) {
				// error occurred making the output directory
				switch(errno) {
					case EEXIST:
						// Directory already exists, ignore
						break;
					case ENOENT:
						fprintf(stderr,"Unable to create directory (Path does not exist.): %s\n",temp2);
						return 4;
						break;
					default:
						fprintf(stderr,"Unable to create directory (Error %d): %s\n",errno,newdir);
						return 4;
						break;
				}
			}
			strcpy(prevdir,temp2);
		}
		sprintf(temp2,"%s%s%s",newdir,filepath+strlen(indir),filename);
//		Copy the file
		
		if (CopyFile(temp1,temp2,0) == 0) {
			// Copy Error
			FormatMessage( 
				FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | 
				FORMAT_MESSAGE_IGNORE_INSERTS, NULL,GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
				(LPTSTR) &lpMsgBuf,	0,NULL);
			fprintf(stderr,"%s ===> %s: Copy Failed. %s\n",temp1,temp2,lpMsgBuf);
			LocalFree( lpMsgBuf );
			rc = 8;
		}
		else
			printf("%s ===> %s: OK\n",temp1,temp2);

	}
	if (rc)
		fprintf(stderr,"One or more errors occurred while copying files.\n");
	return rc;
}
